9886a8da64c92e70a8e35f5390b36a858f067d94
[gnulib.git] / tests / init.sh
1 # source this file; set up for tests
2
3 # Copyright (C) 2009, 2010 Free Software Foundation, Inc.
4
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
9
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
17
18 # Using this file in a test
19 # =========================
20 #
21 # The typical skeleton of a test looks like this:
22 #
23 #   #!/bin/sh
24 #   . "${srcdir=.}/init.sh"; path_prepend_ .
25 #   Execute some commands.
26 #   Note that these commands are executed in a subdirectory, therefore you
27 #   need to prepend "../" to relative filenames in the build directory.
28 #   Note that the "path_prepend_ ." is useful only if the body of your
29 #   test invokes programs residing in the initial directory.
30 #   For example, if the programs you want to test are in src/, and this test
31 #   script is named tests/test-1, then you would use "path_prepend_ ../src",
32 #   or perhaps export PATH='$(abs_top_builddir)/src$(PATH_SEPARATOR)'"$$PATH"
33 #   to all tests via automake's TESTS_ENVIRONMENT.
34 #   Set the exit code 0 for success, 77 for skipped, or 1 or other for failure.
35 #   Use the skip_ and fail_ functions to print a diagnostic and then exit
36 #   with the corresponding exit code.
37 #   Exit $?
38
39 # Executing a test that uses this file
40 # ====================================
41 #
42 # Running a single test:
43 #   $ make check TESTS=test-foo.sh
44 #
45 # Running a single test, with verbose output:
46 #   $ make check TESTS=test-foo.sh VERBOSE=yes
47 #
48 # Running a single test, with single-stepping:
49 #   1. Go into a sub-shell:
50 #   $ bash
51 #   2. Set relevant environment variables from TESTS_ENVIRONMENT in the
52 #      Makefile:
53 #   $ export srcdir=../../tests # this is an example
54 #   3. Execute the commands from the test, copy&pasting them one by one:
55 #   $ . "$srcdir/init.sh"; path_prepend_ .
56 #   ...
57 #   4. Finally
58 #   $ exit
59
60 ME_=`expr "./$0" : '.*/\(.*\)$'`
61
62 # We use a trap below for cleanup.  This requires us to go through
63 # hoops to get the right exit status transported through the handler.
64 # So use `Exit STATUS' instead of `exit STATUS' inside of the tests.
65 # Turn off errexit here so that we don't trip the bug with OSF1/Tru64
66 # sh inside this function.
67 Exit () { set +e; (exit $1); exit $1; }
68
69 # Print warnings (e.g., about skipped and failed tests) to this file number.
70 # Override by defining to say, 9, in init.cfg, and putting say,
71 # "export ...ENVVAR_SETTINGS...; exec 9>&2; $(SHELL)" in the definition
72 # of TESTS_ENVIRONMENT in your tests/Makefile.am file.
73 # This is useful when using automake's parallel tests mode, to print
74 # the reason for skip/failure to console, rather than to the .log files.
75 : ${stderr_fileno_=2}
76
77 warn_() { echo "$@" 1>&$stderr_fileno_; }
78 fail_() { warn_ "$ME_: failed test: $@"; Exit 1; }
79 skip_() { warn_ "$ME_: skipped test: $@"; Exit 77; }
80 framework_failure_() { warn_ "$ME_: set-up failure: $@"; Exit 99; }
81
82 # Sanitize this shell to POSIX mode, if possible.
83 DUALCASE=1; export DUALCASE
84 if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
85   emulate sh
86   NULLCMD=:
87   alias -g '${1+"$@"}'='"$@"'
88   setopt NO_GLOB_SUBST
89 else
90   case `(set -o) 2>/dev/null` in
91     *posix*) set -o posix ;;
92   esac
93 fi
94
95 # We require $(...) support unconditionally.
96 # We require a few additional shell features only when $EXEEXT is nonempty,
97 # in order to support automatic $EXEEXT emulation:
98 # - hyphen-containing alias names
99 # - we prefer to use ${var#...} substitution, rather than having
100 #   to work around lack of support for that feature.
101 # The following code attempts to find a shell with support for these features.
102 # If the current shell passes the test, we're done.  Otherwise, test other
103 # shells until we find one that passes.  If one is found, re-exec it.
104 # If no acceptable shell is found, skip the current test.
105 #
106 # The "...set -x; P=1 true 2>err..." test is to disqualify any shell that
107 # emits "P=1" into err, as /bin/sh from SunOS 5.11 and OpenBSD 4.7 do.
108 #
109 # Use "9" to indicate success (rather than 0), in case some shell acts
110 # like Solaris 10's /bin/sh but exits successfully instead of with status 2.
111
112 gl_shell_test_script_='
113 test $(echo y) = y || exit 1
114 test -z "$( (exec 3>&1; set -x; P=1 true 2>&3) 2> /dev/null)" || exit 1
115 test -z "$EXEEXT" && exit 9
116 shopt -s expand_aliases
117 alias a-b="echo zoo"
118 v=abx
119      test ${v%x} = ab \
120   && test ${v#a} = bx \
121   && test $(a-b) = zoo \
122   && exit 9
123 '
124
125 if test "x$1" = "x--no-reexec"; then
126   shift
127 else
128   # 'eval'ing the above code makes Solaris 10's /bin/sh exit with $? set to 2.
129   # It does not evaluate any of the code after the "unexpected" `('.  Thus,
130   # we must run it in a subshell.
131   ( eval "$gl_shell_test_script_" ) > /dev/null 2>&1
132   if test $? = 9; then
133     : # The current shell is adequate.  No re-exec required.
134   else
135     # Search for a shell that meets our requirements.
136     for re_shell_ in "${CONFIG_SHELL:-no_shell}" /bin/sh bash dash zsh pdksh fail
137     do
138       test "$re_shell_" = no_shell && continue
139       test "$re_shell_" = fail && skip_ failed to find an adequate shell
140       "$re_shell_" -c "$gl_shell_test_script_" 2>/dev/null
141       if test $? = 9; then
142         # Found an acceptable shell.  Preserve -v and -x.
143         case $- in
144           *v*x* | *x*v*) opts_=-vx ;;
145           *v*) opts_=-v ;;
146           *x*) opts_=-x ;;
147           *) opts_= ;;
148         esac
149         exec "$re_shell_" $opts_ "$0" --no-reexec "$@"
150         echo "$ME_: exec failed" 1>&2
151         exit 127
152       fi
153     done
154   fi
155 fi
156
157 test -n "$EXEEXT" && shopt -s expand_aliases
158
159 # Enable glibc's malloc-perturbing option.
160 # This is cheap and useful for exposing code that depends on the fact that
161 # malloc-related functions often return memory that is mostly zeroed.
162 # If you have the time and cycles, use valgrind to do an even better job.
163 : ${MALLOC_PERTURB_=87}
164 export MALLOC_PERTURB_
165
166 # This is a stub function that is run upon trap (upon regular exit and
167 # interrupt).  Override it with a per-test function, e.g., to unmount
168 # a partition, or to undo any other global state changes.
169 cleanup_() { :; }
170
171 if ( diff --version < /dev/null 2>&1 | grep GNU ) > /dev/null 2>&1; then
172   compare() { diff -u "$@"; }
173 elif ( cmp --version < /dev/null 2>&1 | grep GNU ) > /dev/null 2>&1; then
174   compare() { cmp -s "$@"; }
175 else
176   compare() { cmp "$@"; }
177 fi
178
179 # An arbitrary prefix to help distinguish test directories.
180 testdir_prefix_() { printf gt; }
181
182 # Run the user-overridable cleanup_ function, remove the temporary
183 # directory and exit with the incoming value of $?.
184 remove_tmp_()
185 {
186   __st=$?
187   cleanup_
188   # cd out of the directory we're about to remove
189   cd "$initial_cwd_" || cd / || cd /tmp
190   chmod -R u+rwx "$test_dir_"
191   # If removal fails and exit status was to be 0, then change it to 1.
192   rm -rf "$test_dir_" || { test $__st = 0 && __st=1; }
193   exit $__st
194 }
195
196 # Given a directory name, DIR, if every entry in it that matches *.exe
197 # contains only the specified bytes (see the case stmt below), then print
198 # a space-separated list of those names and return 0.  Otherwise, don't
199 # print anything and return 1.  Naming constraints apply also to DIR.
200 find_exe_basenames_()
201 {
202   feb_dir_=$1
203   feb_fail_=0
204   feb_result_=
205   feb_sp_=
206   for feb_file_ in $feb_dir_/*.exe; do
207     case $feb_file_ in
208       *[!-a-zA-Z/0-9_.+]*) feb_fail_=1; break;;
209       *) # Remove leading file name components as well as the .exe suffix.
210          feb_file_=${feb_file_##*/}
211          feb_file_=${feb_file_%.exe}
212          feb_result_="$feb_result_$feb_sp_$feb_file_";;
213     esac
214     feb_sp_=' '
215   done
216   test $feb_fail_ = 0 && printf %s "$feb_result_"
217   return $feb_fail_
218 }
219
220 # Consider the files in directory, $1.
221 # For each file name of the form PROG.exe, create an alias named
222 # PROG that simply invokes PROG.exe, then return 0.  If any selected
223 # file name or the directory name, $1, contains an unexpected character,
224 # define no function and return 1.
225 create_exe_shims_()
226 {
227   case $EXEEXT in
228     '') return 0 ;;
229     .exe) ;;
230     *) echo "$0: unexpected \$EXEEXT value: $EXEEXT" 1>&2; return 1 ;;
231   esac
232
233   base_names_=`find_exe_basenames_ $1` \
234     || { echo "$0 (exe_shim): skipping directory: $1" 1>&2; return 1; }
235
236   if test -n "$base_names_"; then
237     for base_ in $base_names_; do
238       alias "$base_"="$base_$EXEEXT"
239     done
240   fi
241
242   return 0
243 }
244
245 # Use this function to prepend to PATH an absolute name for each
246 # specified, possibly-$initial_cwd_-relative, directory.
247 path_prepend_()
248 {
249   while test $# != 0; do
250     path_dir_=$1
251     case $path_dir_ in
252       '') fail_ "invalid path dir: '$1'";;
253       /*) abs_path_dir_=$path_dir_;;
254       *) abs_path_dir_=`cd "$initial_cwd_/$path_dir_" && echo "$PWD"` \
255            || fail_ "invalid path dir: $path_dir_";;
256     esac
257     case $abs_path_dir_ in
258       *:*) fail_ "invalid path dir: '$abs_path_dir_'";;
259     esac
260     PATH="$abs_path_dir_:$PATH"
261
262     # Create an alias, FOO, for each FOO.exe in this directory.
263     create_exe_shims_ "$abs_path_dir_" \
264       || fail_ "something failed (above): $abs_path_dir_"
265     shift
266   done
267   export PATH
268 }
269
270 setup_()
271 {
272   test "$VERBOSE" = yes && set -x
273
274   initial_cwd_=$PWD
275
276   pfx_=`testdir_prefix_`
277   test_dir_=`mktempd_ "$initial_cwd_" "$pfx_-$ME_.XXXX"` \
278     || fail_ "failed to create temporary directory in $initial_cwd_"
279   cd "$test_dir_"
280
281   # This trap statement, along with a trap on 0 below, ensure that the
282   # temporary directory, $test_dir_, is removed upon exit as well as
283   # upon receipt of any of the listed signals.
284   for sig_ in 1 2 3 13 15; do
285     eval "trap 'Exit $(expr $sig_ + 128)' $sig_"
286   done
287 }
288
289 # Create a temporary directory, much like mktemp -d does.
290 # Written by Jim Meyering.
291 #
292 # Usage: mktempd_ /tmp phoey.XXXXXXXXXX
293 #
294 # First, try to use the mktemp program.
295 # Failing that, we'll roll our own mktemp-like function:
296 #  - try to get random bytes from /dev/urandom
297 #  - failing that, generate output from a combination of quickly-varying
298 #      sources and gzip.  Ignore non-varying gzip header, and extract
299 #      "random" bits from there.
300 #  - given those bits, map to file-name bytes using tr, and try to create
301 #      the desired directory.
302 #  - make only $MAX_TRIES_ attempts
303
304 # Helper function.  Print $N pseudo-random bytes from a-zA-Z0-9.
305 rand_bytes_()
306 {
307   n_=$1
308
309   # Maybe try openssl rand -base64 $n_prime_|tr '+/=\012' abcd first?
310   # But if they have openssl, they probably have mktemp, too.
311
312   chars_=abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789
313   dev_rand_=/dev/urandom
314   if test -r "$dev_rand_"; then
315     # Note: 256-length($chars_) == 194; 3 copies of $chars_ is 186 + 8 = 194.
316     dd ibs=$n_ count=1 if=$dev_rand_ 2>/dev/null \
317       | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
318     return
319   fi
320
321   n_plus_50_=`expr $n_ + 50`
322   cmds_='date; date +%N; free; who -a; w; ps auxww; ps ef; netstat -n'
323   data_=` (eval "$cmds_") 2>&1 | gzip `
324
325   # Ensure that $data_ has length at least 50+$n_
326   while :; do
327     len_=`echo "$data_"|wc -c`
328     test $n_plus_50_ -le $len_ && break;
329     data_=` (echo "$data_"; eval "$cmds_") 2>&1 | gzip `
330   done
331
332   echo "$data_" \
333     | dd bs=1 skip=50 count=$n_ 2>/dev/null \
334     | LC_ALL=C tr -c $chars_ 01234567$chars_$chars_$chars_
335 }
336
337 mktempd_()
338 {
339   case $# in
340   2);;
341   *) fail_ "Usage: $ME DIR TEMPLATE";;
342   esac
343
344   destdir_=$1
345   template_=$2
346
347   MAX_TRIES_=4
348
349   # Disallow any trailing slash on specified destdir:
350   # it would subvert the post-mktemp "case"-based destdir test.
351   case $destdir_ in
352   /) ;;
353   */) fail_ "invalid destination dir: remove trailing slash(es)";;
354   esac
355
356   case $template_ in
357   *XXXX) ;;
358   *) fail_ "invalid template: $template_ (must have a suffix of at least 4 X's)";;
359   esac
360
361   fail=0
362
363   # First, try to use mktemp.
364   d=`unset TMPDIR; mktemp -d -t -p "$destdir_" "$template_" 2>/dev/null` \
365     || fail=1
366
367   # The resulting name must be in the specified directory.
368   case $d in "$destdir_"*);; *) fail=1;; esac
369
370   # It must have created the directory.
371   test -d "$d" || fail=1
372
373   # It must have 0700 permissions.  Handle sticky "S" bits.
374   perms=`ls -dgo "$d" 2>/dev/null|tr S -` || fail=1
375   case $perms in drwx------*) ;; *) fail=1;; esac
376
377   test $fail = 0 && {
378     echo "$d"
379     return
380   }
381
382   # If we reach this point, we'll have to create a directory manually.
383
384   # Get a copy of the template without its suffix of X's.
385   base_template_=`echo "$template_"|sed 's/XX*$//'`
386
387   # Calculate how many X's we've just removed.
388   template_length_=`echo "$template_" | wc -c`
389   nx_=`echo "$base_template_" | wc -c`
390   nx_=`expr $template_length_ - $nx_`
391
392   err_=
393   i_=1
394   while :; do
395     X_=`rand_bytes_ $nx_`
396     candidate_dir_="$destdir_/$base_template_$X_"
397     err_=`mkdir -m 0700 "$candidate_dir_" 2>&1` \
398       && { echo "$candidate_dir_"; return; }
399     test $MAX_TRIES_ -le $i_ && break;
400     i_=`expr $i_ + 1`
401   done
402   fail_ "$err_"
403 }
404
405 # If you want to override the testdir_prefix_ function,
406 # or to add more utility functions, use this file.
407 test -f "$srcdir/init.cfg" \
408   && . "$srcdir/init.cfg"
409
410 setup_ "$@"
411 # This trap is here, rather than in the setup_ function, because some
412 # shells run the exit trap at shell function exit, rather than script exit.
413 trap remove_tmp_ 0